<template>
  <div :class="className" :style="{height:height,width:width}" />
</template>

<script>
import * as echarts from 'echarts'
require('echarts/theme/macarons') // echarts theme
import resize from './mixins/resize'

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    width: {
      type: String,
      default: '100%'
    },
    height: {
      type: String,
      default: '300px'
    },
    autoResize: {
      type: Boolean,
      default: true
    },
    chartData: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      chart: null
    }
  },
  watch: {
    chartData: {
      deep: true,
      handler(val) {
        this.setOptions(val)
      }
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.initChart()
    })
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    initChart() {
      this.chart = echarts.init(this.$el, 'macarons')
      this.setOptions(this.chartData)
    },
    setOptions({ x, y1,y2 } = {}) {
      console.log(x,y1,y2)
      this.chart.setOption({
        xAxis: {
          data: x,
          // boundaryGap: false,
          axisTick: {
            show: false
          },
          axisLine: {
                                  lineStyle: {
                                      color: '#666666',
                                      width: 1, //这里是为了突出显示加上的
                                  }
                              },
        },
        grid: {
          left: 10,
          right: 10,
          bottom: 20,
          top: 30,
          containLabel: true
        },
        tooltip: {
          trigger: 'axis',
          axisPointer: {
            type: 'cross'
          },
          padding: [5, 10]
        },
        yAxis: {
          axisTick: {
            show: true
          },
		  
		  splitLine: {
		         show: false
		     },
          lineStyle: {
                          type: 'dotted' // 或者'dotted'
                      },
          axisLine: {
                                  lineStyle: {
                                      color: '#3D455B',
                                      width: 1, //这里是为了突出显示加上的
                                  }
                              },
        },
        legend: {
          data: []
        },
        series: [{
          name: '本年度累计产值', itemStyle: {
			  emphasis: {
			          barBorderRadius: [10, 10, 10, 10]
			        },
            normal: {
              color: new echarts.graphic.LinearGradient(0, 1, 0, 0, [{  
              // 四个数字分别对应 数组中颜色的开始位置，分别为 右，下，左，上。例如（1,0,0,0 ）代表从右边开始渐
              // 变。offset取值为0~1，0代表开始时的颜色，1代表结束时的颜色，柱子表现为这两种颜色的渐变。
                        offset: 0,
                        color: '#F5FCFF'
                      }, {
                        offset: 1,
                        color: '#2777D0'
                      }]),
			  barBorderRadius: [10, 10, 0, 0]
            }
          },
          smooth: true,
          type: 'bar',
		   barWidth: '20px',
          data: y1,
          animationDuration: 2800,
          animationEasing: '总投资额'
        },
        {
          name: '本会计年度实缴税收',
          type: 'line',
		   smooth: false, // 关闭平滑曲线
          itemStyle: {
            normal: {
              color: '#FFB132',
              lineStyle: {
                color: '#FFB132',
                width: 2
              },
            }
          },
          data: y2,
          animationDuration: 2800,
          animationEasing: '固定资产投资额'
        }]
      })
	  window.addEventListener('resize', function() {
	  					myChart.resize()
	  				});   
    }
  }
}
</script>
